#include<stdio.h>
#include<dos.h>
#include<bios.h>
#include<stdlib.h>
#include<conio.h>
#include<ctype.h>
#include<time.h>
#include<stdio.h>
#include "dskdef.h"

struct parameter {
	   unsigned int  pgm_cnt;
	   unsigned int  entrypoint;
	   unsigned int  inverse;
	   unsigned int  com; // comport
	   unsigned long speed; // Baudrate
	 } prm;
const char* programme ="Digital oscilloscope";
const char* pgmdate   ="15.07.95";
const char* version   ="3.00";
const char* copyright ="Copyright (c) 1995 Texas Instruments";
FILE  *stream;        // global for this file

// global variables
unsigned int       pcom;

//extern void WaitFor(unsigned int what);
//extern void InitPort(void);
//extern void reset50(void);
//extern void BaudRateDetect(void);
//extern unsigned int InitMonitor(void);
//extern void initializemonitor(void);
//extern void sendbyte(unsigned int send);
//extern unsigned int sendword(unsigned int send);
//extern unsigned int GetDskAdd(char* pbuf);
//extern unsigned int GetDskData(char* pbuf,unsigned int *data);
//extern void sendcommand(const cmd,unsigned int startaddress,unsigned int length);
//extern double LoadDsk(void);
//extern void ExePgm(void);
//extern unsigned char Bcrcv(int port_no);
//===============================================================


//=================Wait For ===========================================

void WaitFor(unsigned int what)
{
 int j=10000,i=j;

 while(!(inportb(pcom+LSR) & what) && i--);

 if(i<1){
    fprintf(stdout,"Handshake error"
	    "\r\nWait loop finished in WaitFor() with start=%d",j);
    exit(1);
 }
 else return;
}
//End (WaitFor)




//=================initPort =================================================

void InitPort(void)
{
  unsigned int port_no;
  unsigned int  COMADD[]={0x3f8, 0x2f8, 0x3e8, 0x2e8};
  int   BRD=115200l/prm.speed;
  pcom = COMADD[prm.com];
  port_no=pcom;

  asm  mov  DX,word ptr port_no  //
  asm  add  DX,3                 //
  asm  mov  AL,087h              // SET BAUD access
  asm  out  DX,AL                //
  asm  sub  DX,3                 //
  asm  mov  AX,word ptr BRD  //LO// Set 19200 baud
  asm  out  DX,AL                //
  asm  add  DX,1                 //
  asm  mov  AL,byte ptr BRD  //HI//
  asm  xchg AL,AH                //
  asm  out  DX,AL                //
  asm  sub  DX,1                 //
  asm  add  DX,3                 //
  asm  mov  AL,07h               // CLR BAUD access...  N-8-2
  asm  out  DX,AL                //
  asm  out  DX,AL                // N-8-2
  asm  mov  DX,port_no           //0x3FC 0x2FC  modem control register
  asm  add  DX,5                 //check LINE_STATUS  0x2FD  0x3FD (+5)
xempty0:                         //
  asm  in   AL,DX                //
  asm  and  AL,060h              //wait for DXR & TXR to empty before RST!
  asm  cmp  AL,060h              //
  asm  jne  xempty0              //
}

//end (initPort)

//=================reset 50 =================================================

void reset50(void)
{
  unsigned int  port_no=pcom;
  if(prm.inverse) {               // do the inverse DTR for reset of c50
     asm  mov  DX,word ptr port_no//modem control register  02FC 03FC
     asm  add  DX,4               //
     asm  mov  AL,0xB             //RTS=1, DTR=0
     asm  out  DX,AL
     delay(1);
     asm  mov  DX,word ptr port_no//modem control register
     asm  add  DX,4               //
     asm  mov  AL,0xA             //RTS=1, DTR=0
     asm  out  DX,AL
     delay(1);
     asm  mov  DX,word ptr port_no//modem control register
     asm  add  DX,4               //
     asm  mov  AL,0xB             //RTS=1, DTR=0
     asm  out  DX,AL
     delay(1);
  }
  else  {                        // else we have a hardware negate function from PC to c50
     asm  mov  DX,word ptr port_no//modem control register
     asm  add  DX,4               //
     asm  mov  AL,0xA             //RTS=1, DTR=0
     asm  out  DX,AL
     delay(1);
     asm  mov  DX,word ptr port_no//modem control register
     asm  add  DX,4               //
     asm  mov  AL,0xB             //RTS=1, DTR=0
     asm  out  DX,AL
     delay(1);
     asm  mov  DX,word ptr port_no//modem control register
     asm  add  DX,4               //
     asm  mov  AL,0xA             //RTS=1, DTR=0
     asm  out  DX,AL
     delay(1);
  }
}
//end (reset50)


//=================BaudRateDetect============================================
void BaudRateDetect(void)
{
 reset50();
 delay(12);        // v.02 ROM code need delay for boot loader

 if(prm.speed<57600){
    while(!(inportb(pcom+LSR) & XMT_BUF_EMPTY));
    outportb(pcom,0x80);    // write a byte to the com port (320c50)
 }
 else
    outportb(pcom,0x80);    // write a byte to the com port (320c50)
}

//end (BaudRateDetect)

//=================initmonitor ==============================================
unsigned int InitMonitor(void)
{
  int  i=10000;
  int  ans=inportb(pcom+LSR);
  int  byte_return;
  unsigned int send;               // test for reponse with random pattern

  while(!(ans & DATA_READY) && i){  // data received?
	ans = inportb(pcom+LSR);
	i--;
  }
  if(i<1)
     return  0;
  if( inportb(pcom)!=KB_ESC)
      return 2;

   delay(1);
   send=0xAA;               // test for reponse with random pattern
   WaitFor(XMT_BUF_EMPTY);       // wait for buff empty
   outportb(pcom,send);          // send a byte
   WaitFor(DATA_READY);          // wait for data received
   delay(1);
   if ((byte_return=inportb(pcom))!=send) {
       printf("\nbyte recieve = %x\n",byte_return);
       return 1;
   }
   WaitFor(XMT_BUF_EMPTY);       // wait for buff empty
   outportb(pcom,(send=KB_ESC)); // send a byte
   WaitFor(DATA_READY);          // wait for data received
   delay(1);
   if ((byte_return=inportb(pcom))==send)
       return 3;                // all tests are successful!
   return 1;
}
//end (initmonitor)


//=================initializemonitor=========================================

void initializemonitor(void) /*altered on 03/01/95*/
{
 unsigned int num;
 unsigned int error;
 int pass=FALSE;


 InitPort(); //initialise serial com regiaters.

 pass=FALSE;
 BaudRateDetect(); //send 0x80 to DSP to calculate BITLEN.
 delay(2);  // what is the right time ??? was 1 up to version 0.98

 switch(error=InitMonitor())
 {
	case 0:
	case 1:
	case 2:   pass=FALSE;
		  break;
	case 3:   pass=TRUE;
		  break;

 }


 if(!pass){
    clrscr();
    printf("\nCommunication not successful\n");
    switch(error) {
      case 0: printf("\nNo Response.\n");
	      break;
      case 1: printf("\nTest Error.\n");
	      break;
      case 2: printf("\nNo Escape.\n");
	      break;
     default: break;
    }
    exit(1);
 }
}

//end (initilizemonitor)


//=================SendByte =================================================
void sendbyte(unsigned int send)
{
  unsigned int receive;
  WaitFor(XMT_BUF_EMPTY);        // wait for buff empty

  outportb(pcom,send);           // send a byte

  WaitFor(DATA_READY);           // wait for data received
  delay(1);
  receive=inportb(pcom);
  if (receive!=send)
      fprintf(stdout,"Handshake error"
		 "\r\nSent byte in 'sendbyte()' is not correct!\r\n"
		 "Sent    : 0x%02x   Received: 0x%02x\r\n",send,receive);
}
//end (sendbyte);


//=================sendword =================================================
unsigned int sendword(unsigned int send)
{
 unsigned int   s1;
 unsigned int   receive;

 WaitFor(XMT_BUF_EMPTY);          // wait for empty
 s1 = (send>>8)&0xff;
 outportb(pcom,s1);   // send high byte of end address

 WaitFor(DATA_READY);             // wait for data rec
 delay(1);
 receive=inportb(pcom);

 WaitFor(XMT_BUF_EMPTY);
 s1 = send&0xff;
 outportb(pcom,s1);        // send low  byte of end address

 WaitFor(DATA_READY);             // wait for data rec
 delay(1);
 if((receive=(receive<<8)+inportb(pcom))!=send)
    fprintf(stdout,"Handshake error"
		 "\r\nSent word in sendword() is not correct!\r\n"
		 "Sent    : %04xh   Received: %04xh\r\n",send,receive);

 return receive; // return sent word for check if necessary
 }
//end (sendword)

//=================GetDskAdd ================================================
unsigned int GetDskAdd(char* pbuf)
{
 unsigned int x=0,i=4;
 char c=*pbuf++;
 for(;i;i--,c=*pbuf++)
   {
    x =(x<<4) + c;
    if(isdigit(c))
      x -= '0';
    else
      x -= 'A'-10;
   }
 return x;
}
//end (getDSkAdd)

//=================GetDskData ===============================================
unsigned int GetDskData(char* pbuf,unsigned int *data)
{
 unsigned int x,num=0,i;
 unsigned char c;

 while(*(pbuf++)!='7')
   {
    for(*data=0,i=4;i;i--)
      {
       c = *pbuf++;
       *data<<=4;
       if(isdigit(c))
	 *data +=c-'0';
       else
	 *data +=c-'A'+10;
      }
     data++;
     num++;
   }

 return num;
}
//end (GetDSKData)


//=================SendCommand ==============================================
void sendcommand(const cmd,unsigned int startaddress,unsigned int length)
{
  sendbyte(cmd);
  sendword(startaddress);
  sendword(length-1);
}


//--------------------------------------------------------------------
//--- Load a program/data file in TI-Dsk Format: default ext. dsk   --
//--------------------------------------------------------------------
double LoadDsk(void)
{
 char    linebuf[MAXLINE], *pbuf=linebuf;
 unsigned int    line=0;        // line counter of file
 unsigned int    data[MAXLINE]; // max 100. words to download
 unsigned int    numdata=0;     // num of words to download
 unsigned long   sumdata=0;     // sum of all downloaded words
 unsigned int    address;       // address for     download
 unsigned int    program;       // type: if program 'yes' , no if data 'no'
 double   d;

 clock_t start=clock();
 while(1) {                                    // for all lines
     pbuf=fgets(linebuf,MAXLINE,stream);

     switch(*pbuf){                            // analyse line
	case  ':':
	case NULL: fclose(stream);
		   fprintf(stdout,"\nLoading of prog/data finished");
		   d=clock()-start;
		   return d>0 ? d : 0.001;
	case  'K': numdata=0;break;           // Do something with the name ?
	case  '9': address=GetDskAdd(pbuf+1); // DSK for an address
		   switch(*(pbuf+5))
		     {
		      case '7': break;        // Do nothing with checksum   ?
		      case 'M': program=no; break;
		      case 'B': program=yes; break;
		      default : fprintf(stdout,"\n\nerror 1: 'Wrong Tag "
					"in Pos 6'!\n\n\rPlease check whether"
				   " the file is a valid *.dsk file!\n\n\r");
				return 0;
		     }
		   numdata=GetDskData(pbuf+5,data);
		   sumdata +=numdata;
		   break;
	case  '1': address=GetDskAdd(pbuf+1);          // Entry address
		   if(address==0)
		     break; // dska generates address=0 if no entry defined!

		   prm.pgm_cnt=prm.entrypoint=address;
		   break;
	default  : fprintf(stdout,"\n\nerror 2: 'Wrong Tag in Pos 1' in LoadDsk()"
				"!\n\n\rPlease check whether"
				" the file is a valid *.dsk file!\n\n\r");
		   return 0;
       }

     if(numdata){                                    // download line
	unsigned int i,cmd=(program==yes) ? LP:LD;

	fprintf(stdout,"\r   %4d %5d %8ld  %s",
		     ++line,numdata,sumdata,program ? "program":"data");
	sendcommand(cmd,address,numdata);
	for(i=0;i<numdata;i++) sendword(data[i]);
     }
 }
}

//end (loadDSK)

//=================ExePgm====================================================
void ExePgm(void)
{
 sendbyte(XG); sendword(prm.pgm_cnt);    // execute
 outportb(pcom,NULL);               // Startpulse / sync for windows/OS2 ??????
 return;
}
//end (ExePgm)


//=================Bcrcv=====================================================

char Bcrcv(int port_no)
{
  char c;
  asm  mov  DX,word ptr port_no // RECV a character
  asm  add  DX,5                // check LINE_STATUS  0x2FD  0x3FD (+5)
  asm  mov  BX,4000             // 836 loops is marginal at 4800 baud.
chkst:                          // with 33MHz 486
  asm  sub  bx,1                //
  asm  jz   timerr              //
  asm  in   AL,DX               //
  asm  and  AL,061h             //
  asm  cmp  AL,061h             //
  asm  jne  chkst               // wait for DRR & RSR to fill
  asm  sub  DX,5                //
  asm  in   AL,DX               //
  asm  mov  byte ptr c,AL       //                                             
  return(c);                    //                                             
timerr:                         //                                             
  return(-1);                   //                                             
}
//end(bcrcv)

